/*
 *  Black Jack
 *
 *  Created by Govs
 *  e-mail: arturogovea@gmail.com
 *  Copyright 2014. All rights reserved.
 *
 */ 
#define SAVE_SCREEN
#define USE_TI89
#include <tigcclib.h>
#include <stdio.h>

//define the global constants
#define SPRITE_HEIGHT   12
#define SHOWCARDS 7
#define F1 268
#define F2 269
#define F3 270
#define F4 271
#define F5 272
 
    //Static variables
    static int ndecks=1;
    static char soft17='1';
    static char showd='1';
    static int count_scroll=0;
    static int player_count=0;
    static long int bet[10]={0,0,0,0,0,0,0,0,0,0};
    static long int scores[10]={0,0,0,0,0};
    static char name_scores[10][15]={"Score1","Score2","Score3","Score4","Score5"};
    static char name_player[10][15]={"Name1","Name2","Name3","Name4","Name5","Name6","Name7","Name8","Name9","Name10"};
    // Variables
    int x=0,y=0,i,j,k,g,l,r=0,s=0,b=0,auxc=0,auxf=0,h=0;
    long int be=0;
    char rep;
    int mc[416],mf[416];
    char pauc[15];
    

// define the bj21 sprites
unsigned short int esp[] ={0x0200,0x0700,0x0F80,0x1FC0,0x3FE0,
0x7FF0,0xFFF8,0xFFF8,0xFAF8,0x7270,0x0200,0x0F80};

unsigned short int cor[] = {0x0000,0x78F0,0x8508,0x8208,0x8008,0x8008,
0x4010,0x2020,0x1040,0x0880,0x0500,0x0200};

unsigned short int dia[] ={0x0000,0x0200,0x0500,0x0880,0x1040,0x2020,
0x4010,0x2020,0x1040,0x0880,0x0500,0x0200};

unsigned short int tre[] ={0x0000,0x0700,0x0F80,0x0F80,0x0F80,
0x3FE0,0x7FF0,0x7FF0,0x7FF0,0x3AE0,0x0200,0x0700};

unsigned long int card[] ={0x7FFFE000,0xC0003000,0x80001000,0x80001000,0x80001000,0x80001000,0x80001000,0x80001000,0x80001000,0x80001000,
0x80001000,0x80001000,0x80001000,0x80001000,0x80001000,0x80001000,0x80001000,0x80001000,0x80001000,0x80001000,0x80001000,0x80001000,0x80001000,0xC0003000,0x7FFFE000};
  
unsigned short int *fig[] = {cor,esp,dia,tre};
    
void delay(float d)
{
  OSFreeTimer (USER_TIMER);
  OSRegisterTimer (USER_TIMER, d*20);
  while (!OSTimerExpired (USER_TIMER));	
}

void bar()
{
    DrawStr(50,35,"Loading",A_NORMAL);      
    DrawLine(5,50,151,50,A_NORMAL);
    DrawLine(5,50,5,60,A_NORMAL);
    DrawLine(5,60,151,60,A_NORMAL);
    DrawLine(151,50,151,60,A_NORMAL);
} 
int key=0;int counts=0;
int menu()
{
	FontSetSys (F_8x10);
	j=0;counts=0;
	char *mstring[7]={"Play","Select Player","Scores","Settings","Help","About","Exit"};
	do
	{
	  ClrScr();
            for(i=0;i<5;i++)
	    {
		DrawStr(20,15+15*i,mstring[i+counts],A_NORMAL);      
       	    }
		DrawLine(10,15+15*j,10,25+15*j,A_NORMAL);
		DrawLine(10,15+15*j,15,20+15*j,A_NORMAL);
		DrawLine(10,25+15*j,15,20+15*j,A_NORMAL);
		while (!kbhit())key=0; 
		key = ngetchx();
		DrawLine(10,15+15*j,10,25+15*j,A_REVERSE);
		DrawLine(10,15+15*j,15,20+15*j,A_REVERSE);
		DrawLine(10,25+15*j,15,20+15*j,A_REVERSE);
		if(key==338||key==340)j++;
		if(key==337||key==344)j--;
		        if(j>4)
			{
			  j=4;
			  counts++;
			}
			if(j<0)
			{
				j=0;
				counts--;
			}
                        if((counts+j)>6)
			{
				counts=0;
				j=0;
			}
			if((counts+j)<0)
			{
				counts=2;
				j=4;
			}
                if(key==264){j=7;break;}
	}while(key!=13);
	ClrScr();
	return j+counts;
} 
void dalg(char nm[2]) //show status square 
{
   ClrScr();
   for(g=0;g<2;g++)
   {
   	for(k=0;k<9;k++)
   	{
	  DrawClipEllipse(15+16*k,10+g*80, 8, 8, &(SCR_RECT){{0, 0, 230, 120}}, A_NORMAL);	
          DrawClipEllipse(15+16*k,10+g*80, 7, 7, &(SCR_RECT){{0, 0, 230, 120}}, A_NORMAL);	
   	  printf_xy(10+16*k,7+g*80,nm);
   	}
   	for(k=0;k<4;k++)
   	{
	  DrawClipEllipse(15+128*g,26+k*16, 8, 8, &(SCR_RECT){{0, 0, 230, 120}}, A_NORMAL);	
          DrawClipEllipse(15+128*g,26+k*16, 7, 7, &(SCR_RECT){{0, 0, 230, 120}}, A_NORMAL);	
   	  printf_xy(10+128*g,23+16*k,nm);
   	}
   }
}
int contn=0;int indc=0;
void select_player()
{
	FontSetSys (F_8x10);
	j=0;
	key=0;counts=0;
	char *mstring[4]={"Edit Player","Select Player","Erase Player","Exit"};
        selectp:
	ClrScr();
        for(i=0;i<4;i++)
	{
	   DrawStr(20,10+15*i,mstring[i],A_NORMAL);      
	}
	do
	{
		DrawLine(10,10+15*j,10,20+15*j,A_NORMAL);
		DrawLine(10,10+15*j,15,15+15*j,A_NORMAL);
		DrawLine(10,20+15*j,15,15+15*j,A_NORMAL);
		while (!kbhit())key=0; 
		key = ngetchx();
		DrawLine(10,10+15*j,10,20+15*j,A_REVERSE);
		DrawLine(10,10+15*j,15,15+15*j,A_REVERSE);
		DrawLine(10,20+15*j,15,15+15*j,A_REVERSE);
		if(key==338||key==340)j++;
		if(key==337||key==344)j--;
		if(j>3)j=0;
		if(j<0)j=3;
                if(key==264)
                {j=4;break;}
	}while(key!=13);
        ClrScr();
	if(j==0)
	{ 
          counts=0;
		do
		{
			for(i=0;i<6;i++)
			{
				DrawStr(20,10+15*i,name_player[i+counts],A_NORMAL);   
			}
			DrawLine(10,10+15*j,10,20+15*j,A_NORMAL);
			DrawLine(10,10+15*j,15,15+15*j,A_NORMAL);
			DrawLine(10,20+15*j,15,15+15*j,A_NORMAL);
			while (!kbhit())key=0; 
			key = ngetchx();
			ClrScr();
			if(key==338||key==340)j++;
			if(key==337||key==344)j--;
			if(j>5)
			{
			  j=5;
			  counts++;
			}
			if(j<0)
			{
				j=0;
				counts--;
			}
                        if((counts+j)>9)
			{
				counts=0;
				j=0;
			}
			if((counts+j)<0)
			{
				counts=4;
				j=5;
			}
                        if(key==264){j=0;goto selectp;}
      		}while(key!=13);
                clrscr();puts ("\n\n\n\n ");
                printf_xy(5,25,"Enter your name:");
		getsn(pauc,15);
                strcpy(name_player[j+counts],pauc);  
		j=0;//ClrScr();
		goto selectp;
	}
	
	if(j==1)
	{
	  //int contn=0;const char *nomb=name_player[player_count];
          contn=0;
          indc=0;
          //contn=strlen(nomb)+2;
          j=player_count-count_scroll;
	  if(j>5)j=5;if(j<0)j=0;
		do
		{
			for(i=0;i<6;i++)
			{
				DrawStr(20,10+15*i,name_player[i+count_scroll],A_NORMAL);
				if(j==i)indc=i+count_scroll;
			}
			contn=strlen(name_player[indc]);
			//if(strcmp("Nameie10",name_player[indc])==0)contn++;
                          
                        DrawLine(18,7+15*j,21+contn*8,7+15*j,A_NORMAL);
                        DrawLine(18,21+15*j,21+contn*8,21+15*j,A_NORMAL);
			DrawLine(18,7+15*j,18,21+15*j,A_NORMAL);
			DrawLine(21+contn*8,7+15*j,21+contn*8,21+15*j,A_NORMAL);

			DrawLine(10,10+15*j,10,20+15*j,A_NORMAL);
			DrawLine(10,10+15*j,15,15+15*j,A_NORMAL);
			DrawLine(10,20+15*j,15,15+15*j,A_NORMAL);
			while (!kbhit())key=0; 
			key = ngetchx();
			ClrScr();
			//reverse
			if(key==338||key==340)j++;
			if(key==337||key==344)j--;
			if(j>5)
			{
			  j=5;
			  count_scroll++;
			}
				
			if(j<0)
			{
				j=0;
				count_scroll--;
			}
                        if((count_scroll+j)>9)
			{
				count_scroll=0;
				j=0;
			}
			if((count_scroll+j)<0)
			{
				count_scroll=4;
				j=5;
			}
			if(key==264){j=0;goto selectp;}
                        if(key==109||key==F5)
                        {
 			  DrawStr(20,20,name_player[j+count_scroll],A_NORMAL);
			  printf_xy(20,35,"$%li",bet[j+count_scroll]);
			  ngetchx();
			  ClrScr();
                          if(bet[j+count_scroll]>=300000)
                          {
                          FontSetSys (F_6x8);  
                           dalg("21");
                           printf_xy(40,40,"YOU CAN GO TO");
 	                   printf_xy(45,50,"HARVARD MED");
 	                   printf_xy(65,60,"SCHOOL");
                           ngetchx();
			   ClrScr();
                          FontSetSys (F_8x10);  
                          }
                        }
		}while(key!=13);
		player_count=j+count_scroll;
		j=0;//ClrScr();
		goto selectp;
	}
	if(j==2)
	{
           j=0;counts=0;
			do
			{
				for(i=0;i<6;i++)
				{
					DrawStr(20,10+15*i,name_player[i+counts],A_NORMAL);   	
				}
				DrawLine(10,10+15*j,10,20+15*j,A_NORMAL);
				DrawLine(10,10+15*j,15,15+15*j,A_NORMAL);
				DrawLine(10,20+15*j,15,15+15*j,A_NORMAL);
				while (!kbhit())key=0; 
				key = ngetchx();
				ClrScr();
				if(key==338||key==340)j++;
				if(key==337||key==344)j--;
				if(j>5)
				{
					j=5;
					counts++;
				}
				
				if(j<0)
				{
					j=0;
					counts--;
				}
				if((counts+j)>9)
				{
					counts=0;
					j=0;
				}
				if((counts+j)<0)
				{
					counts=4;
					j=5;
				}
                                if(key==264){j=0;goto selectp;}
			}while(key!=13);

			int q=0;
			char *mstring[6]={"Yes","No"};
			char auco[22]="";
			strcat(auco,"Erase ");
			strcat(auco,name_player[j+counts]);
			strcat(auco," ?");
			DrawStr(0,20,auco,A_NORMAL);
			for(i=0;i<2;i++)
			{
				DrawStr(10,35+15*i,mstring[i],A_NORMAL);      
			}
			do
			{
				DrawLine(0,35+15*q,0,45+15*q,A_NORMAL);
				DrawLine(0,35+15*q,5,40+15*q,A_NORMAL);
				DrawLine(0,45+15*q,5,40+15*q,A_NORMAL);
				while (!kbhit())key=0; 
				key = ngetchx();
				DrawLine(0,35+15*q,0,45+15*q,A_REVERSE);
				DrawLine(0,35+15*q,5,40+15*q,A_REVERSE);
				DrawLine(0,45+15*q,5,40+15*q,A_REVERSE);
				if(key==338||key==340)q--;
				if(key==337||key==344)q++;
				if(q>1)q=0;
				if(q<0)q=1;
			}while(key!=13);
			if(q==0)
			{
				char c[8];int idx=j+counts+1;
				sprintf(c,"Name%i",idx);
				strcpy(name_player[j+counts],c);
                                bet[j+counts]=100;
			}
			j=0;//ClrScr();
			goto selectp;
	}
}
void scramble(int ndecks)
{
    //intializing arrray
    for (i = 0; i < 52*ndecks; i++)mc[i]=random(13)+1;
    //generate bj21 deck
    bar();
    for (k=0;k<4*ndecks;k++)
    {  
    do
    {	
      rep='0';	
       for (i=13*k;i<13*k+13;i++)
       {
       	for (j=13*k;j<i;j++)
       	{
       	  if(mc[i]==mc[j]&&i!=j)
       	  {
       	  	mc[i]=random(13)+1;rep='1';
       	  }
       	}
       }
       for(i=0;i<7;i++)
       {
       	 DrawLine(7+r,52+i,12+s,52+i,A_NORMAL);
       }
        r=r+6;s=r-1;
       if(r==150)
       {
       	r=0;s=0;
       	ClrScr(); bar();
       }
       delay(0.06);
     }while(rep=='1');
     }
     while(r!=144)
     {
     	 for(i=0;i<7;i++)
       {
       	 DrawLine(7+r,52+i,12+s,52+i,A_NORMAL);
       }
        r=r+6;s=r-1;
        delay(0.06);
     }
     r=0;s=0;
     
}
void figdis(int ndecks)
{   
    //intializing arrray
    for (i = 0; i < 52*ndecks; i++)mf[i]=random(4)+1;
    b=random(4);
    bar();
    //scrambling figures
    for (k=0;k<4*ndecks;k++)
    {  
       for (i=13*k;i<13*k+13;i++)
       {
        if(mc[i]==1)mf[i]=b;
      	if(mc[i]==2)mf[i]=b;
        if(mc[i]==3)mf[i]=b;
       	if(mc[i]==4)mf[i]=b;
        if(mc[i]==5)mf[i]=b;
      	if(mc[i]==6)mf[i]=b;
        if(mc[i]==7)mf[i]=b;
       	if(mc[i]==8)mf[i]=b;
        if(mc[i]==9)mf[i]=b;
        if(mc[i]==10)mf[i]=b;
        if(mc[i]==11)mf[i]=b;
        if(mc[i]==12)mf[i]=b;
       	if(mc[i]==13)mf[i]=b;
       }
       b++;
       if(b==4)b=0;
       for(i=0;i<7;i++)
       {
       	 DrawLine(7+r,52+i,12+s,52+i,A_NORMAL);
       }
        r=r+6;s=r-1;
       if(r==150)
       {
       	r=0;s=0;
       	ClrScr(); bar();
       }
       delay(0.06);
     }
     while(r!=144)
     {
       for(i=0;i<7;i++)
       {
       	 DrawLine(7+r,52+i,12+s,52+i,A_NORMAL);
       }
        r=r+6;s=r-1;
        delay(0.06);
     }
     r=0;s=0;b=0;
}
void portada()
{
    FontSetSys (F_6x8);
    ClrScr();
    //Drawing "2"
    for(i=0;i<3;i++)
    {
    	for(j=0;j<3;j++)
    	{
      	DrawClipEllipse (45+16*i,20+32*j, 8, 8, &(SCR_RECT){{0, 0, 230, 120}}, A_NORMAL);	
        DrawClipEllipse (45+16*i,20+32*j, 7, 7, &(SCR_RECT){{0, 0, 230, 120}}, A_NORMAL);	
        DrawStr (39+16*i,17+32*j,"21", A_NORMAL);    		
    	}
    }
    //for(i=1;i<2;i++)
    //{
      	DrawClipEllipse (77,35, 8, 8, &(SCR_RECT){{0, 0, 230, 120}}, A_NORMAL);	
        DrawClipEllipse (77,35, 7, 7, &(SCR_RECT){{0, 0, 230, 120}}, A_NORMAL);	
        DrawStr (71,32,"21", A_NORMAL);   			
    //}
    //for(i=1;i<2;i++)
    //{
      	DrawClipEllipse (45,67, 8, 8, &(SCR_RECT){{0, 0, 230, 120}}, A_NORMAL);	
        DrawClipEllipse (45,67, 7, 7, &(SCR_RECT){{0, 0, 230, 120}}, A_NORMAL);	
        DrawStr (39,64,"21", A_NORMAL); 		
    //}    
    //Drawing "1"
    for(i=0;i<5;i++)
    {
    	DrawClipEllipse (110,20+16*i, 8, 8, &(SCR_RECT){{0, 0, 230, 120}}, A_NORMAL);	
        DrawClipEllipse (110,20+16*i, 7, 7, &(SCR_RECT){{0, 0, 230, 120}}, A_NORMAL);	
        DrawStr (104,17+16*i,"21", A_NORMAL);    		
    }
    //Drawing aces cards
    Sprite32(2,2,25,card, LCD_MEM, SPRT_XOR);  
    Sprite16(6,13, SPRITE_HEIGHT,fig[0], LCD_MEM, SPRT_XOR);  
    DrawStr (9,4,"A", A_NORMAL);   
    Sprite32(2,72,25,card, LCD_MEM, SPRT_XOR);      
    Sprite16(6,83,SPRITE_HEIGHT,fig[1], LCD_MEM, SPRT_XOR); 
    DrawStr (9,74,"A", A_NORMAL);
           
    Sprite32(135,2,25,card, LCD_MEM, SPRT_XOR);       
    Sprite16(139,13, SPRITE_HEIGHT,fig[3], LCD_MEM, SPRT_XOR);  
    DrawStr (142,4,"A", A_NORMAL);   
    Sprite32(135,72,25,card, LCD_MEM, SPRT_XOR);      
    Sprite16(139,83, SPRITE_HEIGHT,fig[2], LCD_MEM, SPRT_XOR);  
    DrawStr (142,74,"A", A_NORMAL);   
    //ngetchx();
    delay(1);
    ClrScr();
}

void let(int aux,int x,int y)
{
  //convert to letters and strings
  if(aux==1)DrawStr (7+x,2+y,"A",A_NORMAL); 
  if(aux==2)printf_xy(7+x,2+y,"%d",aux);
  if(aux==3)printf_xy(7+x,2+y,"%d",aux);
  if(aux==4)printf_xy(7+x,2+y,"%d",aux);
  if(aux==5)printf_xy(7+x,2+y,"%d",aux);
  if(aux==6)printf_xy(7+x,2+y,"%d",aux);
  if(aux==7)printf_xy(7+x,2+y,"%d",aux);
  if(aux==8)printf_xy(7+x,2+y,"%d",aux);
  if(aux==9)printf_xy(7+x,2+y,"%d",aux);
  if(aux==10)printf_xy(4+x,2+y,"%d",aux);
  if(aux==11)DrawStr (7+x,2+y,"J",A_NORMAL); 
  if(aux==12)DrawStr (7+x,2+y,"Q",A_NORMAL); 
  if(aux==13)DrawStr (7+x,2+y,"K",A_NORMAL);  
}
int osf=0;
void showdeck(int ndecks)
{
    //show whole deck
    osf=0;g=0;
    for(j=1;j<=ndecks;j++)
    {
    
    if (j==1) 
    {osf=0;}
    else
    {osf=1;}
    key=0;
    do
    {
    x=0;y=0;
    if(g==0)
    {
    for (k=0;k<4;k++)
    {  
       for (i=8*(4*(j-1)+k)+4*osf;i<8*(4*(j-1)+k)+8+4*osf;i++)
       {
         Sprite32(x,y,25,card, LCD_MEM, SPRT_XOR);  
         Sprite16(4+x,11+y, SPRITE_HEIGHT,fig[mf[i]], LCD_MEM, SPRT_XOR);    
         let(mc[i],x,y);
         x+=20;
       }
      y+=25;
      x=0;
    }
     } 
     else
     {
     
    for (k=0;k<2;k++)
    {  
       for (i=32+8*(4*(j-1)+k)+4*osf;i<32+8*(4*(j-1)+k)+8+4*osf;i++)
       {
         Sprite32(x,y,25,card, LCD_MEM, SPRT_XOR);  
         Sprite16(4+x,11+y, SPRITE_HEIGHT,fig[mf[i]], LCD_MEM, SPRT_XOR);    
         let(mc[i],x,y);
         x+=20;
       }
      y+=25;
      x=0;
    }
       for (i=48*j;i<4+48*j;i++)
       {
         Sprite32(x,y,25,card, LCD_MEM, SPRT_XOR);  
         Sprite16(4+x,11+y, SPRITE_HEIGHT,fig[mf[i]], LCD_MEM, SPRT_XOR);    
         let(mc[i],x,y);
         x+=20;
       }
     }
     while (!kbhit())key=0; 
     key = ngetchx();
     if(key==338||key==340)g++;
     if(key==337||key==344)g--;
     if(g<0)g=1;
     if(g>1)g=0;
     ClrScr();
    }while(key!=13 && key!=F5);
    }
}
void shuffle(int ndecks)
{
   for(k=0;k<169*ndecks;k++)
   {
   	 j=random(52*ndecks);
   	 randomize();
   	 i=random(52*ndecks);
     auxc=mc[j]; mc[j]=mc[i];mc[i]=auxc;
     auxf=mf[j];mf[j]=mf[i];mf[i]=auxf;
   }
   for(k=0;k<52;k++)
   {
   	 randomize();
   	 i=random(52*ndecks);
     auxc=mc[k]; mc[k]=mc[i];mc[i]=auxc;
     auxf=mf[k];mf[k]=mf[i];mf[i]=auxf;
   }
}

/*int summ(int su,int i)
{
	if(mc[i]==1)
	{
		if(su<=10)su=11+su;
		else su=mc[i]+su;
	}
	if(mc[i]>10)su=10+su;
	if(mc[i]<=10&&mc[i]!=1)su=mc[i]+su;
  return su;
}*/
void help()
{
    FontSetSys (F_6x8);
    DrawStr (5,5,"Press:",A_NORMAL);
    DrawStr (5,20,"F1 or'h' to hit",A_NORMAL);
    DrawStr (5,35,"F2 or 'd' to double",A_NORMAL);
    DrawStr (5,50,"F3 or 'e' to surrender",A_NORMAL);
    DrawStr (5,65,"F4 or 's' to split ",A_NORMAL);
    DrawStr (5,80,"F5 or 'ENTER' to stand",A_NORMAL);
    ngetchx();
}
void about()
{
    DrawStr (20,10,"BlackJack 21",A_NORMAL);
    FontSetSys (F_6x8);
    DrawStr (5,30,"Inspired on the movie 21",A_NORMAL);
    DrawStr (5,50,"Several years ago",A_NORMAL);
    DrawStr (5,70,"by Arturo Govea Vargas",A_NORMAL);
    DrawStr (5,90," arturogovea@gmail.com",A_NORMAL);
    //DrawStr (10,90,"Press ",A_NORMAL);
    //DrawStr (10,110,"Press",A_NORMAL);
    ngetchx();
}
//int bt[11];long int beto;
/*void bets()
{
	beto=bet[player_count];	
	for(i=0;i<11;i++)
	{
	 bt[i]=beto%10;	
	 beto=beto/10;
	}
	printf_xy(5,109,"MONEY");	
	DrawClipEllipse(45,112, 8, 8, &(SCR_RECT){{0, 0, 230, 120}}, A_NORMAL);	
    	DrawClipEllipse(45,112, 7, 7, &(SCR_RECT){{0, 0, 230, 120}}, A_NORMAL);	
    	printf_xy(42,109,"$"); 	 	
  	for(i=0;i<11;i++)
	{
		DrawClipEllipse(61+16*i,112, 8, 8, &(SCR_RECT){{0, 0, 230, 120}}, A_NORMAL);	
		DrawClipEllipse(61+16*i,112, 7, 7, &(SCR_RECT){{0, 0, 230, 120}}, A_NORMAL);	
		printf_xy(58+16*i,109,"%d",bt[10-i]); 		
	}	
}*/
void beta(char q)
{
 if(q=='1')bet[player_count]=bet[player_count]+be;
 if(q=='0')bet[player_count]=bet[player_count]-be;
 if(bet[player_count]<=0)
 {
        ngetchx();
 	dalg("XX");
 	printf_xy(50,35,"YOU CANNOT");
 	printf_xy(55,45,"BEAT THE");
 	printf_xy(60,55,"SYSTEM");
 }
 ngetchx();ClrScr();
 //LCD_restore(LCD_BUFFER);bets();
}
int sigma(int somp[21])
{
 int i=0,suma=0,one=0,contu=0;
 int unos[21]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}; 
for(i=0;i<21;i++)
{
  if(somp[i]==441)
  {break;}
  else 
  {
   if(mc[somp[i]]==1)
   {unos[one]=1;one++;}
   else
   {
     if((mc[somp[i]]==11)||(mc[somp[i]]==12)||(mc[somp[i]]==13))suma=suma+10;else suma=suma+mc[somp[i]];
   }
  }   
}
for(i=0;i<21;i++)
{
  if(unos[i]==0)break;
  contu++;
}
if(contu>2)
{
  if(suma+11+contu-1<21)suma=suma+11+contu-1;
  else{suma=suma+contu;}
}
else
{
 if(contu!=0)
 {
 if(contu==2){if(suma<=9)suma=suma+12;else suma=suma+2;}
 else{if(suma<=10)suma=suma+11;else suma=suma++;}
 }
}
return suma;
}
int getlength(int som[21])
{
  int length=0;
   for(i=0;i<21;i++)
   {
	if(som[i]==441) break;
	length++;	
   }
   return length;
}
void highscore()
{
 for(k=0;k<5;k++)
 { 
  if(scores[k]<= bet[player_count])
  {
    break;
  }
 }
 if(scores[k]!= bet[player_count])
 {
 for(i=4;i>=k;i--)
 {
   strcpy(name_scores[i],name_scores[i-1]);
   scores[i]=scores[i-1];
 }
  strcpy(name_scores[k],name_player[player_count]);
  scores[k]=bet[player_count];
 }
}
//Status messages
//1 TIE 2 Surrender 3 Won 4 Lost 5 Busted
void pmstatus(int status)
{
  switch(status)
  {
    case 1:printf_xy(72,45,"TIE");break;
    case 2:printf_xy(52,45,"SURRENDER");break;
    case 3:printf_xy(72,45,"WON");break;
    case 4:printf_xy(65,45,"LOST");break;
    case 5:printf_xy(60,45,"BUSTED");break;
    default: break;
  }
}
//Variables of playgame that were necessary to make global
    char buffer[11];
    long int gama=0; 
    const char *name;char surrend='0';char split='0';char doubl='0';
    int count_ssp=0;int consumps=0;char up='1';int count_sp=0;int consump=0;
    int sump=0,sumd=0,cont=0,sumps=0;int consum=0;int cardi=3;int count_s=0;
    int somp[21]={2,3,441,441,441,441,441,441,441,441,441,441,441,441,441,441,441,441,441,441,441};
int somd[21]={0,1,441,441,441,441,441,441,441,441,441,441,441,441,441,441,441,441,441,441,441};
int somps[21]={441,441,441,441,441,441,441,441,441,441,441,441,441,441,441,441,441,441,441,441,441}; 

void playgame(void){
    play:
    surrend='0';split='0';doubl='0';
    key=0;sump=0;sumd=0;cont=0,sumps=0;consum=0;cardi=3;count_s=0;
    for(k=0;k<21;k++)
    {
     somp[k]=441;somd[k]=441;somps[k]=441;
    }
    somp[0]=2;somp[1]=3;
    somd[0]=0;somd[1]=1;
    
    if(bet[player_count]<=0)
    {
     bet[player_count]=100;
    }
    name=name_player[player_count];
    cont=strlen(name);
    
    FontSetSys (F_6x8);
    shuffle(ndecks);
    //Initial Bet
    bet:
    clrscr();
    puts("\n\n\n\n\n  ");
    printf_xy(10,25,"Enter your bet:");
    be=atol(getsn(buffer,11));
    if (be > bet[player_count])
    {
      ClrScr();
      printf_xy(10,20,"Your bet exceeds your money");
      printf_xy(10,35,"You just have: $%li",bet[player_count]);
      ngetchx();
      goto bet;
    }
    if(be<=0)be=(int)bet[player_count]*0.1;
    //be=3000000;//ngetchx();
    consum=getlength(somp);
    if(consum>11)count_s=consum-11;else count_s=0;
    do
    {
    ClrScr(); //bets();
    //Dealer Initial Cards
    DrawStr (5,2,"DEALER",A_NORMAL);
    Sprite32(5,10,25,card, LCD_MEM, SPRT_XOR);  
    Sprite32(25,10,25,card, LCD_MEM, SPRT_XOR);  
    Sprite16(29,20,SPRITE_HEIGHT,fig[mf[1]], LCD_MEM, SPRT_XOR);    
    let(mc[1],25,10);
    //ShowCards of player
   for(i=0;i<SHOWCARDS;i++)
   { 
    if(somp[i+count_s]==441) break;  
    DrawStr (5,40,name,A_NORMAL);
    Sprite32(5+20*(i),50,25,card, LCD_MEM, SPRT_XOR);  
    Sprite16(9+20*(i),60, SPRITE_HEIGHT,fig[mf[somp[i+count_s]]], LCD_MEM, SPRT_XOR);    
    let(mc[somp[i+count_s]],5+20*(i),50);
   }
   sump=sigma(somp);
   printf_xy(5+cont*6,40,":%i",sump);
   
   if(sump>=21) 
   {
    if(sump==21&&consum==2)be=be*2;
    goto ft;
   }
   if(doubl=='1')
   {
     //delay(1.5);
     break;
   }
   while (!kbhit())key=0; 
   key = ngetchx();
   if(key==338||key==340)count_s--;
   if(key==337||key==344)count_s++;
        if(count_s<0)count_s=0;
	if((i+count_s)>consum)count_s=consum-i;
  
    if(key==115||key==F4)//If player hits s then split
    {
    	if((mc[2]==mc[3])&&(consum==2)) //Go to split mode
    	{
         if((bet[player_count]-be)>0)
         {goto split;}
         else
         {
	ClrScr();
      	printf_xy(10,20,"Your bet exceeds your money");
      	printf_xy(10,35,"You just have: $%li",bet[player_count]);
      	ngetchx();
         }
    	}       
    }
     
    if(key==104||key==F1) //If player hits "h" add a card
    {
      cardi++;	
      somp[consum]=cardi;
      consum=getlength(somp);
      if(consum>SHOWCARDS)count_s=consum-SHOWCARDS;else count_s=0;
    }
    if(key==100||key==F2)//If player hits d then double
    {
    if (be > bet[player_count])
    {
      ClrScr();
      printf_xy(10,20,"Your bet exceeds your money");
      printf_xy(10,35,"You just have: $%li",bet[player_count]);
      ngetchx();
      //be=be/2;
    }
    else
    {
      be=be*2;
      cardi++;	
      somp[consum]=cardi;
      doubl='1';
    }
    }
    if(key==101||key==F3)//If player hits e then surrender
    {
      be=be/2;
      surrend='1';
      goto end;
    }
    if(key==264)goto quit;
    }while(key!=13 && key!=F5);

    goto ft;

    split: //Split mode which will be slightly harder to implement
    split='1';
    somp[0]=2;somp[1]=441;somp[2]=441;somp[3]=441;
    somps[0]=3;somps[1]=441;somps[2]=441;somps[3]=441;
    count_ssp=0;consumps=0;up='1'; 
   consum=getlength(somp);
   if(consum>SHOWCARDS)count_s=consum-SHOWCARDS;else count_s=0;
   consumps=getlength(somps);
   if(consumps>SHOWCARDS)count_ssp=consumps-SHOWCARDS;else count_ssp=0;
    do
    {
    ClrScr();//bets();
    DrawStr (5,2,"DEALER",A_NORMAL);
    Sprite32(5,10,25,card, LCD_MEM, SPRT_XOR);  
    Sprite32(25,10,25,card, LCD_MEM, SPRT_XOR);  
    Sprite16(29,20, SPRITE_HEIGHT,fig[mf[1]], LCD_MEM, SPRT_XOR);    
    let(mc[1],25,10);
   //ShowCards of player first   
   DrawStr (5,40,name,A_NORMAL);
   
   for(i=0;i<SHOWCARDS;i++)
   { 
    if(somp[i+count_s]==441) break;  
    Sprite32(5+20*i,50,25,card, LCD_MEM, SPRT_XOR);  
    Sprite16(9+20*i,60, SPRITE_HEIGHT,fig[mf[somp[i+count_s]]], LCD_MEM, SPRT_XOR);    
    let(mc[somp[i+count_s]],5+20*i,50);
   }
   sump=sigma(somp);
   
   //ShowCards of player second hand
   for(j=0;j<SHOWCARDS;j++)
   { 
    if(somps[j+count_ssp]==441) break;  
    Sprite32(5+20*j,75,25,card, LCD_MEM, SPRT_XOR);  
    Sprite16(9+20*j,85, SPRITE_HEIGHT,fig[mf[somps[j+count_ssp]]], LCD_MEM, SPRT_XOR);    
    let(mc[somps[j+count_ssp]],5+20*j,75);
   }
   sumps=sigma(somps);
    
   printf_xy(5+cont*6,40,":%d/%d",sump,sumps); 

   if(up=='1')
   {
    DrawLine(0,58,0,68,A_NORMAL);
    DrawLine(0,58,5,63,A_NORMAL);
    DrawLine(0,68,5,63,A_NORMAL);
   }
   else
   {
    DrawLine(0,83,0,93,A_NORMAL);
    DrawLine(0,83,5,88,A_NORMAL);
    DrawLine(0,93,5,88,A_NORMAL);
   }
   if(doubl=='1')break;
   //Wait for key to be press
   while (!kbhit())key=0; 
   key = ngetchx();
   if(key==338){if(up=='1')count_s++;else count_ssp++;}
   if(key==344){if(up=='1')count_s--;else count_ssp--;}
        if(count_ssp<0)count_ssp=0;
	if((j+count_ssp)>consumps)count_ssp=consumps-j;
 	if(count_s<0)count_s=0;
	if((i+count_s)>consum)count_s=consum-i;
 
   if(key==340||key==337){if(up=='0')up='1';else up='0';};

   if(key==101||key==F3)//If player hits e then surrender
    {
      be=be/2;
      surrend='1';
      goto end;
    }

   if(key==100||key==F2)//If player hits d then double
    {
    
    if ((bet[player_count]-be)<=0)
    {
      ClrScr();
      printf_xy(10,20,"Your bet exceeds your money");
      printf_xy(10,35,"You just have: $%li",bet[player_count]);
      ngetchx();
      //be=be/2;
    }
    else
    {
      be=be*2;
      if(up=='1')
      {
	if (sump<21)
        {
         cardi++;	
         somp[consum]=cardi;
         consum=getlength(somp);
         if(consum>SHOWCARDS)count_s=consum-SHOWCARDS;else count_s=0;
        }
      }
      else
      {
	if (sumps<21)
        {
         cardi++;	
         somps[consumps]=cardi;
	 consumps=getlength(somps);
   	 if(consumps>SHOWCARDS)count_ssp=consumps-SHOWCARDS;else count_ssp=0;
        }
      }
      doubl='1';
    }
    }
    if(key==104||key==F1) //If player hits "h" add a card
    {
      if(up=='1')
      {
	if (sump<21)
        {
         cardi++;	
         somp[consum]=cardi;
         consum=getlength(somp);
         if(consum>SHOWCARDS)count_s=consum-SHOWCARDS;else count_s=0;
        }
      }
      else
      {
	if (sumps<21)
        {
         cardi++;	
         somps[consumps]=cardi;
	 consumps=getlength(somps);
   	 if(consumps>11)count_ssp=consumps-11;else count_ssp=0;
        }
      }
    }
    
    }while(key!=13 && key!=F5);
    
    ft://Dealer's turn
    do
    {
    ClrScr();//bets();
    //Dealer Cards
    consum=getlength(somd);
    if(consum>SHOWCARDS){count_s=consum-SHOWCARDS;}else{count_s=0;}
    for(i=0;i<SHOWCARDS;i++)
    {
    if(somd[i+count_s]==441) break;   
    DrawStr (5,2,"DEALER",A_NORMAL);
    Sprite32(5+20*i,10,25,card, LCD_MEM, SPRT_XOR);  
    Sprite16(9+20*i,20, SPRITE_HEIGHT,fig[mf[somd[i+count_s]]], LCD_MEM, SPRT_XOR);    
    let(mc[somd[i+count_s]],5+20*i,10);
    }
    sumd=sigma(somd);
    printf_xy(41,2,":%d",sumd);
    //Player Cards
   count_sp=0;consump=0;
   consump=getlength(somp);
   if(consump>SHOWCARDS){count_sp=consump-SHOWCARDS;}else{count_sp=0;}

   for(i=0;i<SHOWCARDS;i++)
   { 
    if(somp[i+count_sp]==441) break;  
    DrawStr (5,40,name,A_NORMAL);
    Sprite32(5+20*(i),50,25,card, LCD_MEM, SPRT_XOR);  
    Sprite16(9+20*(i),60, SPRITE_HEIGHT,fig[mf[somp[i+count_sp]]], LCD_MEM, SPRT_XOR);    
    let(mc[somp[i+count_sp]],5+20*(i),50);
   }
   sump=sigma(somp);
   if (split=='0')
   {printf_xy(5+cont*6,40,":%i",sump);}
   else
   {
   consumps=getlength(somps);
   if(consumps>SHOWCARDS)count_ssp=consumps-SHOWCARDS;else count_ssp=0;
    //Player splited
   for(j=0;j<SHOWCARDS;j++)
   { 
    if(somps[j+count_ssp]==441) break;  
    Sprite32(5+20*j,75,25,card, LCD_MEM, SPRT_XOR);  
    Sprite16(9+20*j,85, SPRITE_HEIGHT,fig[mf[somps[j+count_ssp]]], LCD_MEM, SPRT_XOR);    
    let(mc[somps[j+count_ssp]],5+20*j,75);
   }
   sumps=sigma(somps);    
   printf_xy(5+cont*6,40,":%d/%d",sump,sumps); 
   }
   
    if(consum==2)//Implement soft 17 mode
    {
      if(sumd==17)
      {
        if((mc[0]==1&&mc[1]==6)||(mc[0]==6&&mc[1]==1))
        {
          if(soft17=='1')break;
        }
      }
    }
    
    if(sumd>=sump)
    {
     if(split=='1')
     {
      if(sumd>=sumps)break;
     }
     else{break;}
    }
    if(sumd<21)
    {
      if(sump<=21 && sumps<=21)
      {
      cardi++;
      somd[consum]= cardi;
      //delay(0.4);
      }
      else
      {break;}
    }
    else{break;}
    
    }while(sumd<21);
    delay(1.1);
    //decide who wins
    dalg("21");
    if(sumd==sump)
    {
        be=be/2;
    	pmstatus(1);
        beta('1');
    	if(split=='0')goto end;else goto splitreward;
    } 
    if(sump==21)
    {
    	pmstatus(3);
    	beta('1');
    	if(split=='0')goto end;else goto splitreward;
    }
    if(sumd==21)
    {
    	pmstatus(4);
    	beta('0');
    	if(split=='0')goto end;else goto splitreward;
    }
    if(sump>sumd&&sump<21)
    {
    	pmstatus(3);
    	beta('1');
    	if(split=='0')goto end;else goto splitreward;
    }
    if(sumd>sump&&sumd<21)
    {
    	pmstatus(4);
    	beta('0');
    	if(split=='0')goto end;else goto splitreward;
    }
    if(sumd>sump)
    {
    	pmstatus(3);
    	beta('1');
    	if(split=='0')goto end;else goto splitreward;
    }
    if(sump>sumd)
    {
    	pmstatus(5);
    	beta('0');
    	if(split=='0')goto end;else goto splitreward;
    }
    splitreward:
    //clrscr();ngetchx();
    dalg("21");
    if(sumd==sumps)
    {
        be=be/2;
    	pmstatus(1);
        beta('1');
    	goto end;
    } 
    if(sumps==21)
    {
    	pmstatus(3);
    	beta('1');
    	goto end;
    }
    if(sumd==21)
    {
    	pmstatus(4);
    	beta('0');
    	goto end;
    }
    if(sumps>sumd&&sumps<21)
    {
    	pmstatus(3);
    	beta('1');
    	goto end;
    }
    if(sumd>sumps&&sumd<21)
    {
    	pmstatus(4);
    	beta('0');
    	goto end;
    }
    if(sumd>sumps)
    {
    	pmstatus(3);
    	beta('1');
    	goto end;
    }
    if(sumps>sumd)
    {
    	pmstatus(5);
    	beta('0');
    	goto end;
    }
    end:
    if(surrend=='1')
    {
     dalg("21");
     pmstatus(2);
     beta('0');
    }
    //show balance
    ClrScr();
    printf_xy(5,15,"Balance of:");
    printf_xy(10,30,"%s",name);
    printf_xy(15,45,"$%li",bet[player_count]);
    ngetchx();
    highscore();
    //Show final Display
    key=0;up='1';
    //count_s=0;consum=0;
    //count_sp=0;consump=0;
    //count_ssp=0;consumps=0;
    consum=getlength(somd);
    if(consum>SHOWCARDS){count_s=consum-SHOWCARDS;}else{count_s=0;}
    consump=getlength(somp);
    if(consump>SHOWCARDS){count_sp=consump-SHOWCARDS;}else{count_sp=0;}
    consumps=getlength(somps);
    if(consumps>SHOWCARDS)count_ssp=consumps-SHOWCARDS;else count_ssp=0;
    do
    {
    ClrScr();//bets();
    //Dealer Cards
    for(i=0;i<SHOWCARDS;i++)
    {
    if(somd[i+count_s]==441) break;   
    DrawStr (5,2,"DEALER",A_NORMAL);
    Sprite32(5+20*i,10,25,card, LCD_MEM, SPRT_XOR);  
    Sprite16(9+20*i,20, SPRITE_HEIGHT,fig[mf[somd[i+count_s]]], LCD_MEM, SPRT_XOR);    
    let(mc[somd[i+count_s]],5+20*i,10);
    }
    sumd=sigma(somd);
    printf_xy(41,2,":%d",sumd);
    //Player Cards
    for(j=0;j<SHOWCARDS;j++)
    { 
     if(somp[j+count_sp]==441) break;  
     DrawStr (5,40,name,A_NORMAL);
     Sprite32(5+20*j,50,25,card, LCD_MEM, SPRT_XOR);  
     Sprite16(9+20*j,60, SPRITE_HEIGHT,fig[mf[somp[j+count_sp]]], LCD_MEM, SPRT_XOR);    
     let(mc[somp[j+count_sp]],5+20*j,50);
    }
    sump=sigma(somp);
    if (split=='0')
    {printf_xy(5+cont*6,40,":%i",sump);}
    else
    {
     //Player splited
    for(k=0;k<SHOWCARDS;k++)
    { 
     if(somps[k+count_ssp]==441) break;  
     Sprite32(5+20*k,75,25,card, LCD_MEM, SPRT_XOR);  
     Sprite16(9+20*k,85, SPRITE_HEIGHT,fig[mf[somps[k+count_ssp]]], LCD_MEM, SPRT_XOR);    
     let(mc[somps[k+count_ssp]],5+20*k,75);
     }
     sumps=sigma(somps);    
     printf_xy(5+cont*6,40,":%d/%d",sump,sumps); 
     }
   
   if(up=='0')
   {
    DrawLine(0,18,0,28,A_NORMAL);
    DrawLine(0,18,5,23,A_NORMAL);
    DrawLine(0,28,5,23,A_NORMAL);
   }
   if(up=='1')
   {
    DrawLine(0,58,0,68,A_NORMAL);
    DrawLine(0,58,5,63,A_NORMAL);
    DrawLine(0,68,5,63,A_NORMAL);
   }
   if(up=='2')
   {
    DrawLine(0,83,0,93,A_NORMAL);
    DrawLine(0,83,5,88,A_NORMAL);
    DrawLine(0,93,5,88,A_NORMAL);
   }
   //Wait for key to be press
   while (!kbhit())key=0; 
   key = ngetchx();
   if(key==344){if(up=='0')count_s++;if(up=='1')count_sp++;if(up=='2')count_ssp++;}
   if(key==338){if(up=='0')count_s--;if(up=='1')count_sp--;if(up=='2')count_ssp--;}
        if(count_s<0)count_s=0;
	if((i+count_s)>consum)count_s=consum-i;
        if(count_sp<0)count_sp=0;
	if((j+count_sp)>consump)count_sp=consump-j;
        if(count_ssp<0)count_ssp=0;
	if((k+count_ssp)>consumps)count_ssp=consumps-k;
   if(key==337)
   {
    if(split=='1')
    {
     if(up=='0')up='2';else {if(up=='1')up='0';else up='1';}
    }
    else 
    {
      if(up=='0')up='1';else up='0';
    }
   }
   if(key==340)
   {
    if(split=='1')
    {
     if(up=='0')up='1';else {if(up=='1')up='2'; else up='0';}
    }
    else 
    {
     if(up=='1')up='0';else up='1';
    }
   }
   if(key==264)goto quit;
   }
   while(key!=13 && key!=F5);
    ClrScr();
    //show deck
    if (showd=='1')showdeck(ndecks);
    //show balance
    /*ClrScr();
    printf_xy(20,35,"Balance of %s",name);
    printf_xy(25,50,"$%li",bet[player_count]);*/
    //highscore();
    //Another game or quit
    //while (!kbhit())key=0; 
    //key = ngetchx();
    //if(key!=264)
    quit:
    if(key!=264)goto play;
}
void score()
{
	ClrScr();
	FontSetSys (F_8x10);
	j=0;
	key=0;count_s=0;
	//DrawStr(10,25,"Press 'ENTER' to see the",A_NORMAL);  
	//DrawStr(10,40,"score.",A_NORMAL);      
	//DrawStr(10,55,"Press 'ESC' to exit.",A_NORMAL);	
	//ngetchx();
	scora:        
	ClrScr();
			do
			{
				for(i=0;i<5;i++)
				{
			          DrawStr(20,10+15*i,name_scores[i+count_s],A_NORMAL);   	
				}
				DrawLine(10,10+15*j,10,20+15*j,A_NORMAL);
				DrawLine(10,10+15*j,15,15+15*j,A_NORMAL);
				DrawLine(10,20+15*j,15,15+15*j,A_NORMAL);
				while (!kbhit())key=0; 
				key = ngetchx();
				ClrScr();
				if(key==338||key==340)j++;
				if(key==337||key==344)j--;
				if(j>4)
				{
					j=0;
					//count_s++;
				}
				
				if(j<0)
				{
					j=4;
					//count_s--;
				}
				/*if((count_s+j)>9)
				{
					count_s=0;
					j=0;
				}
				if((count_s+j)<0)
				{
					count_s=4;
					j=5;
				}*/
				
			}while((key!=13)&&(key!=264));
			 
			if (key!=264)
			{
			DrawStr(20,20,name_scores[j+count_s],A_NORMAL);
			printf_xy(20,35,"$%li",scores[j+count_s]);
			ngetchx();
			//ClrScr();
			goto scora;
			}
}
void settings()
{
	FontSetSys (F_8x10);
	j=0;
	int key=0;
	char *mstring[4]={"Number of Decks","Hit / Soft 17","Show Decks","Exit"};

        sett:
        ClrScr();
	for(i=0;i<4;i++)
	{
		DrawStr(20,25+15*i,mstring[i],A_NORMAL);      
	}
	do
	{
		DrawLine(10,25+15*j,10,35+15*j,A_NORMAL);
		DrawLine(10,25+15*j,15,30+15*j,A_NORMAL);
		DrawLine(10,35+15*j,15,30+15*j,A_NORMAL);
		while (!kbhit())key=0; 
		key = ngetchx();
		DrawLine(10,25+15*j,10,35+15*j,A_REVERSE);
		DrawLine(10,25+15*j,15,30+15*j,A_REVERSE);
		DrawLine(10,35+15*j,15,30+15*j,A_REVERSE);
		if(key==338||key==340)j++;
		if(key==337||key==344)j--;
		if(j>3)j=0;
		if(j<0)j=3;
                if(key==264)
                {j=4;break;}
	}while(key!=13);
        ClrScr();
	if(j==0)
	{
	  key=0;
          do
	  { 
            ClrScr();
            DrawStr(0,10,"Press the arrows to",A_NORMAL); 
            DrawStr(0,25,"select the number",A_NORMAL);
	    DrawStr(0,40,"of decks.",A_NORMAL); 
            DrawStr(0,55,"Then press 'ENTER'.",A_NORMAL); 
            printf_xy(70,75,"%i",ndecks);
	    while (!kbhit())key=0; 
	    key = ngetchx();	
	    if(key==338||key==340)ndecks--;
	    if(key==337||key==344)ndecks++;
	    if(ndecks<=0)ndecks=8;
	    if(ndecks>8) ndecks=1;
            if(key==264)
            {j=0;goto sett;}
	  }while(key!=13);
          ClrScr();
	  scramble(ndecks);figdis(ndecks);shuffle(ndecks);
	  j=0;goto sett;
        }
	if(j==1)
        {
	  if (soft17=='0')j=1;else j=0;
		DrawStr(20,25,"Soft 17",A_NORMAL);      
		DrawStr(20,40,"Hit  17",A_NORMAL);      
	do
	{
		DrawLine(19,23+15*j,77,23+15*j,A_NORMAL);
		DrawLine(19,35+15*j,77,35+15*j,A_NORMAL);
		DrawLine(19,23+15*j,19,35+15*j,A_NORMAL);
		DrawLine(77,23+15*j,77,35+15*j,A_NORMAL);

		DrawLine(10,25+15*j,10,35+15*j,A_NORMAL);
		DrawLine(10,25+15*j,15,30+15*j,A_NORMAL);
		DrawLine(10,35+15*j,15,30+15*j,A_NORMAL);
		while (!kbhit())key=0; 
		key = ngetchx();
		DrawLine(10,25+15*j,10,35+15*j,A_REVERSE);
		DrawLine(10,25+15*j,15,30+15*j,A_REVERSE);
		DrawLine(10,35+15*j,15,30+15*j,A_REVERSE);

		DrawLine(19,23+15*j,77,23+15*j,A_REVERSE);
		DrawLine(19,35+15*j,77,35+15*j,A_REVERSE);
		DrawLine(19,23+15*j,19,35+15*j,A_REVERSE);
		DrawLine(77,23+15*j,77,35+15*j,A_REVERSE);

		if(key==338||key==340)j++;
		if(key==337||key==344)j--;
		if(j>1)j=0;
		if(j<0)j=1;
	}while(key!=13);
         if(j==0)soft17='1';
         if(j==1)soft17='0';
	 j=0;goto sett;
        }
	if(j==2)
	{
          key=0;
          do
          {
            ClrScr();
            DrawStr(0,10,"Press 'ENTER' to",A_NORMAL);
            DrawStr(0,25,"change state.",A_NORMAL); 
            DrawStr(0,40,"Press 'ESC' to exit.",A_NORMAL); 
                      
            DrawClipEllipse(70,75, 16, 16, &(SCR_RECT){{0, 0, 230, 120}}, A_NORMAL);
            if(showd=='0')
            {DrawStr(58,71,"OFF",A_NORMAL); }
	    else
	    {DrawStr(62,71,"ON",A_NORMAL); }
            while (!kbhit())key=0; 
	    key = ngetchx();
            if(key==13)
            {
              if(showd=='0')showd='1';else showd='0';
            }
          }while(key!=264);
        }
}

void _main(void)
{
    int aux=0;

    //Initializing game
    FontSetSys (F_6x8);randomize();
    ClrScr();portada(); 
    ClrScr();FontSetSys (F_8x10);scramble(ndecks);figdis(ndecks);
    ClrScr();FontSetSys (F_6x8);   
    start:
	aux=menu();
	switch (aux) {
		case 0: //"Play"
		        playgame();	
                        goto start;
			break;
		case 1: //"Select Player"
			select_player();
			goto start;
			break;
		case 2: //"Scores"
			score();			
			goto start;
			break;
		case 3: //Settings
			settings();
			goto start;
			break;
		case 4: //"Help"
			help();
			goto start;
			break;
		case 5: //"About"
			about();
			goto start;
			break;
		case 6: //"Exit"
			break;
		default:
			break;
	}
}
